;********************************************************
;
;		BBQ_FAN_Inverter
;
;						Maked BY Kazuki Kawade
;
;********************************************************

		LIST	P=PIC12F683
		INCLUDE	"P12F683.INC"
		__CONFIG _INTOSCIO & _BOD_OFF & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF

		errorlevel      -302    ;oNxbZ[W\ɐݒ

;********************************************************
;          ύX
;********************************************************
;2016/08/19	Ver1.00	VK쐬
;2017/03/5	Ver1.10	vgVK쐬Aɔ|[gzuύX
;

;********************************************************
;          |[gZbeBO
;********************************************************
;		Port	I/O		@\		Comment
;
;	GP	0		I		A/D(AN0)	3.3V|CgM[^d
;		1		I		A/D(AN1)	T[~X^d
;		2		O		CCP			FETQ[gPWM[q
;		3		I		-			]pX
;		4		I		A/D(AN3)	ϒR
;		5		O		-			LEDo
;
;
;****************  x`iRAM}bsOj  ********************

	;***** h'70'-h'7F'(16Byte) SoNʂ̂ *****
		cblock  h'70'
w_save		;荞ݎ[LOWX^ۊǗp
s_save		;荞ݎXe[^XWX^ۊǗp
f_save		;荞ݎFSRۊǗp

ee_adr		;EEPROMǂݏoAhX
ee_dat		;EEPROMǂݏof[^

main_t		;C[v׊mFpWX^
maxmain		;ߋő又וۑpWX^
freerun		;t[^C}iLSBFCj

chk_flg		;`FbNtO
chkflg2		;`FbNtO2
err_flg		;G[tO

debug1		;fobOp

		endc

	;***** h'20'-h'5F'(64Byte) oN0̂ *****
		cblock  h'20'
tmr_cnt		;^C}JE^
cnt10m		;10mSecJE^
cnt500m		;500mSecJE^

rot_vol		;ϒRADϊʕۊǗpWX^
dty_out		;Z̏oDutyۊǗpWX^

pls_cnt		;̓pXvpJE^
pls_tmr		;̓pXvԌvpWX^
pls_now		;݂̊mpXۊǗpWX^

tim_cnt		;oߎԍ쐬tO
led_flg		;LED_ŊԊumFptO
led_wnt		;LED_Ń[hvtO
ledcnt1		;LED_œ_ԌvpJE^1
ledcnt2		;LED_œ_ԌvpJE^2

thermo		;T[~X^ADlۊǃWX^
vol33		;di3.3VjۊǃWX^

tgt_pls		;ڕW]ۊǗpWX^

ave_h		;ADϊʕϗpWX^
ave_l		;
ave_cnt		;ω񐔌vpWX^

decreg1		;ZpWX^
decreg2		;
decreg3		;
decreg4		;
decreg5		;
decreg6		;

		endc

	;***** o̓|[g萔` *****
RED_LED		equ		h'05'	;ԐFLED

	;***** `FbNtO萔` *****
DUTY_UP		equ		h'00'	;oDuty㏸w
DUTY_DW		equ		h'01'	;oDuty~w
SW_ON		equ		h'02'	;N㔻tO
WRN_STP		equ		h'03'	;~tO
VOL33EX		equ		h'04'	;ddADϊ{mFtO
WORN_1		equ		h'05'	;ߔMx1
WORN_2		equ		h'06'	;ߔMx2
WORN_3		equ		h'07'	;ߔMx3

	;***** _ŊԊuݒptO` *****
FLASH1		equ		h'00'	;tbVԊu1
FLASH2		equ		h'01'	;tbVԊu2
FLASH3		equ		h'02'	;tbVԊu3
FLASH4		equ		h'03'	;tbVԊu4

	;***** LED_Ń[hvtO` *****
L_MOD_1		equ		h'00'	;vp^[FtbVԊu1
L_MOD_2		equ		h'01'	;vp^[FtbVԊu2
L_MOD_3		equ		h'02'	;vp^[FtbVԊu3
L_MOD_4		equ		h'03'	;vp^[FtbVԊu4
NORM_ON		equ		h'04'	;vp^[F_

	;***** 萔` *****
DTY_MAX		equ		d'16'	;oDutyől
DTY_MIN		equ		d'4'	;oDutyŏl

SWONTIM		equ		d'125'	;NLEDp^[o͂鎞ԁiLEBFC[v x4j

;********************************************************
;          vOX^[g
;********************************************************
        org     0               ;ZbgԒnZbg
        goto    init
        org     4               ;荞ݔԒnZbg
        goto    intrpt

        org		5				;vOJnԒnZbg
init    
;****************  RAMNAX^[g  *********************
		movlw	h'20'			;RAMNAJnAhXZbg
		movwf	FSR				;Z[u

		clrf	INDF			;RAMNA
		incf	FSR,f			;AhX|C^CNg
		movlw	h'80'			;RAMNAIAhXZbg
		subwf	FSR,w			;
		btfss	status,c		;RAMNAIH
		goto	$-5				;	܂̂ߎ̃AhXNA

;****************  PIC Initial START  *********************
		bsf		status,rp0		;oN1I
			movlw	b'01111000'		;Mq̔Mg8MHzɕύX
			movwf	osccon			;
			movlw	b'11010101'		;^C}0JEgNbNɓNbNIAvXP[(64:1)^C}0Ŏgp
			movwf	option_reg		;
			movlw	b'01011001'		;A/DNbNFosc/16IAA/DFAN0,AN3
			movwf	ansel			;
			movlw	b'00011011'		;o͐ݒFGP2,5@͐ݒFGP0,1,3,4
			movwf	trisio			;
			movlw	d'20'			;PWM gZbgi20 * 0.5us = 10us = 100kHzj
			movwf	pr2				;
			movlw	b'00001000'		;GP3̂݃|[gxωɂ銄荞݂B
			movwf	ioc				;

		bcf		status,rp0		;oN0I
		clrf	gpio			;S|[go̓[NA
		movlw	b'00000111'		;Rp[^ItiS|[gfW^I/Oj
		movwf	cmcon0			;

		clrf	ccpr1l				;PWM Duty lZbg
		movlw	b'00000100'			;^C}2@|XgXP[@1F1AvXP[1F1A^C}2L
		movwf	t2con				;
		movlw	b'00001100'			;CCP1 PWM[hփZbg
		movwf	ccp1con				;

;****************  CO  *********************
		;C[voߎԃJE^NA
		clrf	tmr0			;C[voߎԃJE^NA
		bcf		intcon,t0if		;荞ݗvtOZbg

		;荞݋
		bsf		intcon,t0ie		;TMR0荞݋
		bsf		intcon,gpie		;`lxω荞݋
		bsf		intcon,gie		;O[o荞݋

;****************  C[v  *********************
;ȉAC[v͂ǂꂾȂĂK莞ԂŃ[vB
main
;-----------  MA擾Jn  -----------
	;****************  ADl̓͏  *********************
		call	ad_get			;ADl̓͏{

;-----------  MA擾I  -----------
;-----------  ́AZJn  -----------
	;****************  ڕWpX̎Zo  *********************
		call	tgt_cal			;ڕWpX̎Zo

	;****************  ]̉Z  *********************
		call	pls_cal			;̓pX̉]̉Z

	;****************  oDuty̎Zo  *********************
;tB[hobN@ɂǂ炩IB
;		call	dty_cal			;oDuty̎Zoi]ɂtB[hobNj
		call	dty_sel			;oDuty̎ZoiDutywj

	;****************  LED__œe  *********************
		call	led_cal			;LED_œȇI
		call	tim_gen			;LED_ŎԂ̎Zo

;-----------  ́AZI  -----------
;-----------  óA\Jn  -----------
	;****************  oDutỹZbg  *********************
		call	dty_set			;oDutỹZbg

	;****************  LEDo͂̃Zbg  *********************
		call	led_out			;LEDo͂̃Zbg

;-----------  óA\I  -----------
;-----------  C[vŏIJn  -----------
	;****************  t[^C}CNg  *********************
		incf	freerun,f		;t[^C}CNg

	;****************  ׂۑ  *********************
		movf	tmr0,w			;C[vׂvZ邽߃^C}lۑ
		movwf	main_t			;
		subwf	maxmain,w		;ߋ̍ő又גlƔrAΕۑ
		btfsc	status,c		;
		goto	m_wait			;

		movf	main_t,w		;̃[vߋ̍ő又ׂ̂ߕʃWX^ɕۑ
		movwf	maxmain			;

	;****************  C[vIԔ  *********************
;C[vTMR0păCԔsB
;TMR0̃NbN\[XFosc/4gpB
;vXP[ɂ64:1ݒ肵Ă̂ŁA8MHzUq̏ꍇLSB32uSec
;āAJE^ 4000 / 32 = 125 łB
;A125i0x7Djz_ŃC[vIƔ肷B
m_wait	movlw	d'125'			;4mSeco߂ǂ̔
		subwf	tmr0,w			;
		btfss	status,c		;4mSecȏo߂H
		goto	m_wait			;	No. o߂܂őҋ@

		clrf	tmr0			;̂߃C[vvJE^NA

;-----------  C[vŏII  -----------
	;****************  I  *********************
		goto	main

;********************************************************
;          LED_œ_p^[̑I
;********************************************************
led_cal	btfss	chk_flg,SW_ON	;NォH
		goto	swonled			;	Yes.
								;	No.@LEDo͗vmFB

	;****************  T[~X^oxɂLEDo͗vmF  *********************
;T[~X^͓ddADϊdƋpĂ邽ADϊʂ͓ddϓɈˑȂB
;		movlw	d'115'			;30x̃T[~X^oADl
;		movlw	d'104'			;35x̃T[~X^oADl
;		movlw	d'93'			;40x̃T[~X^oADl
;		movlw	d'83'			;45x̃T[~X^oADl
;		movlw	d'75'			;50x̃T[~X^oADl
;		movlw	d'66'			;55x̃T[~X^oADl
;		movlw	d'59'			;60x̃T[~X^oADl
;		movlw	d'53'			;65x̃T[~X^oADl
;		movlw	d'47'			;70x̃T[~X^oADl
;		movlw	d'42'			;75x̃T[~X^oADl
;		movlw	d'37'			;80x̃T[~X^oADl
;		movlw	d'33'			;85x̃T[~X^oADl
;		movlw	d'29'			;90x̃T[~X^oADl
;		movlw	d'26'			;95x̃T[~X^oADl
;		movlw	d'23'			;100x̃T[~X^oADl

		movlw	d'75'			;50x̃T[~X^oADl
		subwf	thermo,w		;
		btfss	status,c		;K艷x𒴂H
		bsf		led_wnt,L_MOD_2	;	Yes. YtOZbg

		movlw	d'59'			;60x̃T[~X^oADl
		subwf	thermo,w		;
		btfss	status,c		;K艷x𒴂H
		bsf		led_wnt,L_MOD_3	;	Yes. YtOZbg

		movlw	d'47'			;70x̃T[~X^oADl
		subwf	thermo,w		;
		btfss	status,c		;K艷x𒴂H
		bsf		led_wnt,L_MOD_4	;	Yes. YtOZbg

		movlw	d'23'			;100x̃T[~X^oADl
		subwf	thermo,w		;
		btfss	status,c		;K艷x𒴂H
		bsf		led_wnt,NORM_ON	;	Yes. YtOZbg
		btfss	status,c		;K艷x𒴂H
		bsf		chk_flg,WRN_STP	;	Yes. ~

	;****************  ddቺɂLEDo͗vmF  *********************
;dd͕ϓ邪d3.3V͕ϓȂADϊʂ̒lȂƓddቺƔfB
;		movlw	d'210'			;4.0VADl
;		movlw	d'205'			;4.1VADl
;		movlw	d'200'			;4.2VADl
;		movlw	d'196'			;4.3VADl
;		movlw	d'191'			;4.4VADl
;		movlw	d'187'			;4.5VADl
;		movlw	d'183'			;4.6VADl
;		movlw	d'179'			;4.7VADl
;		movlw	d'175'			;4.8VADl
;		movlw	d'172'			;4.9VADl
;		movlw	d'168'			;5.0VADl

		movlw	d'191'			;4.4VADl
		subwf	vol33,w		;
		btfsc	status,c		;KdH
		bsf		led_wnt,NORM_ON	;	Yes. YtOZbg

		return

;********** Ñp^[o **********
swonled	bsf		led_wnt,L_MOD_4	;NLEDp^[o͗vtOZbg

	;****************  Np^[o͂鎞ԂvZ  *********************
		incf	ledcnt1,f		;ԌvJE^CNg
		btfsc	status,z		;I[o[t[H
		incf	ledcnt2,f		;	Yes. ʃJE^CNg

		call	decregc			;fR[hWX^NA
			;decreg1	vJE^1
			;decreg2	vJE^2
			;decreg3	gp
			;decreg4	gp
			;decreg5	gp
			;decreg6	gp
		
		movf	ledcnt1,w		;ZWX^ֈړ
		movwf	decreg1			;
		movf	ledcnt2,w		;
		movwf	decreg2			;				

		bcf		status,c		;rbgVtgMSBmɃ[ɂ邽߃L[tO[NA
		rrf		decreg2,f		;
		rrf		decreg1,f		;
		bcf		status,c		;rbgVtgMSBmɃ[ɂ邽߃L[tO[NA
		rrf		decreg2,f		;
		rrf		decreg1,f		;

		movlw	SWONTIM			;NƔ肷鎞ԂƔr
		subwf	decreg1,w		;
		btfss	status,c		;莞Ԉȏo߂H
		return					;	No. o߂܂őҋ@
								;	Yes. ȍ~ANp^[̏o͂͂Ȃ
		clrf	ledcnt1			;vJE^NA
		clrf	ledcnt2			;
		bcf		led_wnt,L_MOD_4	;LEDp^[o͗vtONA
		bsf		chk_flg,SW_ON	;N㔻tOZbg

		return

;********************************************************
;          LEDo͏
;********************************************************
led_out	btfsc	led_wnt,NORM_ON	;_vH
		goto	l_pat_n

		btfsc	led_wnt,L_MOD_4	;LEDp^[4vH
		goto	l_pat_4			;	Yes.
		btfsc	led_wnt,L_MOD_3	;LEDp^[3vH
		goto	l_pat_3			;	Yes.
		btfsc	led_wnt,L_MOD_2	;LEDp^[2vH
		goto	l_pat_2			;	Yes.
		btfsc	led_wnt,L_MOD_1	;LEDp^[1vH
		goto	l_pat_1			;	Yes.


		movf	led_wnt,f		;_yѓ_ŗv͂ЂƂȂH
		btfsc	status,z		;
		bcf		gpio,RED_LED	;	Yes. ԐFLED_OFF

		return

;********** p^[1 **********
l_pat_1	btfsc	led_flg,FLASH1	;
		bsf		gpio,RED_LED	;ԐFLED_ON
		btfss	led_flg,FLASH1	;
		bcf		gpio,RED_LED	;ԐFLED_OFF
		return

;********** p^[2 **********
l_pat_2	btfsc	led_flg,FLASH2	;
		bsf		gpio,RED_LED	;ԐFLED_ON
		btfss	led_flg,FLASH2	;
		bcf		gpio,RED_LED	;ԐFLED_OFF
		return

;********** p^[3 **********
l_pat_3	btfsc	led_flg,FLASH3	;
		bsf		gpio,RED_LED	;ԐFLED_ON
		btfss	led_flg,FLASH3	;
		bcf		gpio,RED_LED	;ԐFLED_OFF
		return

;********** p^[4 **********
l_pat_4	btfsc	led_flg,FLASH4	;
		bsf		gpio,RED_LED	;ԐFLED_ON
		btfss	led_flg,FLASH4	;
		bcf		gpio,RED_LED	;ԐFLED_OFF
		return

;********** p^[_ **********
l_pat_n	bsf		gpio,RED_LED	;	Yes. ԐFLED_ON
		return

;********************************************************
;          oߎԍ쐬
;********************************************************
tim_gen
;********** oߎԂ̐Jn **********
		incf	tim_cnt,f		;1b쐬JE^CNg

	;********** _ŊԊuvZ1 **********
		bsf		led_flg,FLASH1	;_ŎԃtOꎞIɃZbg
		movlw	d'125'			;0.5bo߂H
		subwf	tim_cnt,w		;
		btfss	status,c		;
		bcf		led_flg,FLASH1	;	Yes. _ŊԊutONA

	;********** _ŊԊuvZ2 **********
		movlw	d'1'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH2	;	Yes. _ŊԊutOZbg

		movlw	d'42'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH2	;	Yes. _ŊԊutONA

		movlw	d'83'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH2	;	Yes. _ŊԊutOZbg

		movlw	d'125'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH2	;	Yes. _ŊԊutONA

		movlw	d'166'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH2	;	Yes. _ŊԊutOZbg

		movlw	d'208'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH2	;	Yes. _ŊԊutONA

	;********** _ŊԊuvZ3 **********
		movlw	d'1'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH3	;	Yes. _ŊԊutOZbg

		movlw	d'31'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH3	;	Yes. _ŊԊutONA

		movlw	d'62'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH3	;	Yes. _ŊԊutOZbg

		movlw	d'93'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH3	;	Yes. _ŊԊutONA

		movlw	d'124'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH3	;	Yes. _ŊԊutOZbg

		movlw	d'155'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH3	;	Yes. _ŊԊutONA

		movlw	d'186'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH3	;	Yes. _ŊԊutOZbg

		movlw	d'217'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH3	;	Yes. _ŊԊutONA

	;********** _ŊԊuvZ4 **********
		movlw	d'1'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH4	;	Yes. _ŊԊutOZbg

		movlw	d'15'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH4	;	Yes. _ŊԊutONA

		movlw	d'31'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH4	;	Yes. _ŊԊutOZbg

		movlw	d'46'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH4	;	Yes. _ŊԊutONA

		movlw	d'62'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH4	;	Yes. _ŊԊutOZbg

		movlw	d'78'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH4	;	Yes. _ŊԊutONA

		movlw	d'93'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH4	;	Yes. _ŊԊutOZbg

		movlw	d'109'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH4	;	Yes. _ŊԊutONA

		movlw	d'125'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH4	;	Yes. _ŊԊutOZbg

		movlw	d'140'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH4	;	Yes. _ŊԊutONA

		movlw	d'156'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH4	;	Yes. _ŊԊutOZbg

		movlw	d'171'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH4	;	Yes. _ŊԊutONA

		movlw	d'187'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH4	;	Yes. _ŊԊutOZbg

		movlw	d'203'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH4	;	Yes. _ŊԊutONA

		movlw	d'218'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bsf		led_flg,FLASH4	;	Yes. _ŊԊutOZbg

		movlw	d'234'			;
		xorwf	tim_cnt,w		;
		btfsc	status,z		;
		bcf		led_flg,FLASH4	;	Yes. _ŊԊutONA

	;********** 1bvZ **********
		movlw	d'250'			;1bo߂H
		subwf	tim_cnt,w		;
		btfss	status,c		;
		return					;	No.Ȃ
		clrf	tim_cnt			;	Yes.obt@NA

		return

;********************************************************
;          ڕW]ipXjvZ
;********************************************************
tgt_cal	movf	rot_vol,w		;ϒR̒lWX^ֈړ
		movwf	tgt_pls

		rrf		tgt_pls,f		;ڕW]pX̋e͈͂ɂȂ悤rbgVtg
		rrf		tgt_pls,f
		rrf		tgt_pls,f
		movlw	b'00011111'		;sƂȂĂ3rbg}XN
		andwf	tgt_pls,f		;

		movlw	d'20'			;ڕW]̉lZ
		addwf	tgt_pls,f		;

		return

;********************************************************
;          ̓pXvZ
;********************************************************
pls_cal	incf	pls_tmr,f		;pXJEgԃCNg

		movlw	d'50'			;JEg郁C[v̐
		subwf	pls_tmr,w		;
		btfss	status,c		;K莞Ԉȏo߂H
		return					;	No. Ȃ
		clrf	pls_tmr			;	Yes. v̂߃^C}NA

	;********** pX̕ۊ **********
		movf	pls_cnt,w		;݂̃pXۊ
		movwf	pls_now			;
		clrf	pls_cnt			;JEĝ߃WX^NA

	;********** K͈͂̈E`FbN@ **********
		movf	tgt_pls,w		;KliڕWpXjĂ邩ǂmF
		subwf	pls_now,w		;
		btfss	status,c		;KlȉH
		bsf		chk_flg,DUTY_UP	;	Yes. Duty̏㏸w{
								;	No. `FbN{

	;********** K͈͂̈E`FbN@ **********
		movf	tgt_pls,w		;KlĂ邩ǂmF
		addlw	d'5'			;	Kl͖ڕWpX+5Ƃ
		subwf	pls_now,w		;
		btfsc	status,c		;KlȏォH
		bsf		chk_flg,DUTY_DW	;	Yes.@Dutỷ~w{
								;	No. K͈͓̂߉Ȃ
		return

;i] @7.88ms2pX @200ms50pX
;]@12.83ms2pX

;********************************************************
;          oDutỹZbg
;********************************************************
dty_set	btfsc	chk_flg,WRN_STP	;~tO̓ZbgĂ邩H
		goto	emg_stp			;	Yes. ~
								;	No. ʏ퐧

		movf	dty_out,w		;Zʌ̏oDutyǂݏo
		movwf	ccpr1l			;WX^փZbg

		return

;********** ~ **********
emg_stp	clrf	ccpr1l			;Duty0%o
		return

;********************************************************
;          oDutỷZiDutyw肷@j
;********************************************************
dty_sel	movf	rot_vol,w		;ϒR̒loDutyWX^ֈړ
		movwf	dty_out

		rrf		dty_out,f		;oDuty̕ύXe͈͂ɂȂ悤rbgVtg
		rrf		dty_out,f
		rrf		dty_out,f
		movlw	b'00011111'		;sƂȂĂ3rbg}XN
		andwf	dty_out,f		;

	;********** I[o[mF **********
		movlw	DTY_MAX			;KlĂ邩ǂmF
		subwf	dty_out,w		;
		movlw	DTY_MAX			;
		btfsc	status,c		;KlȏォH
		movwf	dty_out			;	Yes.@ȏDutyグȂ߂Duty̏lݒ肷

	;********** I[o[mF **********
		movlw	DTY_MIN			;KlĂ邩ǂmF
		subwf	dty_out,w		;
		movlw	DTY_MIN			;
		btfss	status,c		;KlȉH
		movwf	dty_out			;	Yes.@ȏDutyȂ߂Dutỷlݒ肷

		return

;********************************************************
;          oDutỷZ
;********************************************************
dty_cal	btfsc	chk_flg,DUTY_UP	;Duty㏸w͂邩H
		incf	dty_out,f		;Duty㏸

		btfsc	chk_flg,DUTY_DW	;Duty~w͂邩H
		decf	dty_out,f		;Duty㏸

		bcf		chk_flg,DUTY_UP	;tONA
		bcf		chk_flg,DUTY_DW	;tONA

	;********** I[o[mF **********
		movlw	DTY_MAX			;KlĂ邩ǂmF
		subwf	dty_out,w		;
		movlw	DTY_MAX			;
		btfsc	status,c		;KlȏォH
		movwf	dty_out			;	Yes.@ȏDutyグȂ߂Duty̏lݒ肷

	;********** I[o[mF **********
		movlw	DTY_MIN			;KlĂ邩ǂmF
		subwf	dty_out,w		;
		movlw	DTY_MIN			;
		btfss	status,c		;KlȉH
		movwf	dty_out			;	Yes.@ȏDutyȂ߂Dutỷlݒ肷

		return

;********************************************************
;          A/Df[^͏
;********************************************************
ad_get
;********** ϒRADϊ **********
		movlw	b'10001101'		;ADϊʉElAAN3IAADϊJnAADϊ@ON
		movwf	adcon0			;
		call	adstart			;A/DϊJn
		call	ave2rrf			;10rbg̕ϊʂ8rbgɂ邽2rbgEVtg
		movf	ave_l,w			;ʌʁi2rbgEVtgĂ邽8rbgADϊʁjĂяo
		movwf	rot_vol			;ʕۑ

;********** T[~X^ADϊ **********
		movlw	b'10000101'		;ADϊʉElAAN1IAADϊJnAADϊ@ON
		movwf	adcon0			;
		call	adstart			;A/DϊJn
		call	ave2rrf			;10rbg̕ϊʂ8rbgɂ邽2rbgEVtg
		movf	ave_l,w			;ʌʁi2rbgEVtgĂ邽8rbgADϊʁjĂяo
		movwf	thermo			;ʕۑ

;********** dADϊ **********
;t@쓮͓ddsɂȂ邽߁AÑt@쓮OɂĂ̂ݓdďosB
		btfsc	chk_flg,VOL33EX	;ADϊ͎{H
		return					;	Yes. ϊ͎{Ȃ	
								;	No. n߂Ď{
		movlw	b'10000001'		;ADϊʉElAAN0IAADϊJnAADϊ@ON
		movwf	adcon0			;
		call	adstart			;A/DϊJn
		call	ave2rrf			;10rbg̕ϊʂ8rbgɂ邽2rbgEVtg
		movf	ave_l,w			;ʌʁi2rbgEVtgĂ邽8rbgADϊʁjĂяo
		movwf	vol33			;ʕۑ

		bsf		chk_flg,VOL33EX	;ADϊtOZbg

		return

;********************************************************
;          ωA/D[`
;********************************************************
adstart	clrf	ave_h			;ωpWX^NA
		clrf	ave_l			;
		movlw	d'6'			;ω񐔂Zbg
		movwf	ave_cnt			;

		call	t20u			;Tvz[hRfT`[Wԑы@imin 19.72usł悢j
		call	t20u			;

		call	decregc			;fR[hWX^NA
			;decreg1	ݒliʁj
			;decreg2	ݒliʁj
			;decreg3	Lőliʁj
			;decreg4	Lőliʁj
			;decreg5	Lŏliʁj
			;decreg6	Lŏliʁj

		movlw	h'FF'			;fpWX^ɏlݒ
		movwf	decreg5			;
		movwf	decreg6			;

re_cnv	bsf		adcon0,go		;A/DJn
		btfsc	adcon0,go		;A/Dϊ͏IH
		goto	$-1				;	No.ēxҋ@

		bsf		status,rp0     		;Bank1I
			movf	adresl,w	;A/Dʓǂݏo
		bcf		status,rp0     		;Bank0I
		movwf	decreg1			;ݒl̉ʂۊ
		addwf	ave_l,f			;ݒl̉ʂ𕽋ωWX^̉ʂ։Z
		btfsc	status,c		;オ͔H
		incf	ave_h,f			;	Yes. ʃWX^CNg

		movf	adresh,w		;A/Dʓǂݏo
		movwf	decreg2			;ݒl̏ʂۊ
		addwf	ave_h,f			;ݒl̏ʂ𕽋ωWX^̏ʂɕۑ

		call	hl_cal			;㉺f

		decfsz	ave_cnt,f		;w񐔏IH
		goto	re_cnv			;	No.

		;6v̂߁A㉺lZ2rbgEVtgsƂŕόʂƂB
		movf	decreg3,w		;ADϊʂ̍őlyэŏlZix#1j
		subwf	ave_l,f			;
		btfss	status,c		;͔H
		decf	ave_h,f			;	Yes. ʌfNg
		movf	decreg4,w		;
		subwf	ave_h,f			;

		movf	decreg5,w		;
		subwf	ave_l,f			;
		btfss	status,c		;͔H
		decf	ave_h,f			;	Yes. ʌfNg
		movf	decreg6,w		;
		subwf	ave_h,f			;

		rrf		ave_l,f			;4̕ς邽ߍZʂ1/4ɂB
		rrf		ave_l,f			;
		movlw	b'00111111'		;sƂȂĂ2rbg[}XN
		andwf	ave_l,f			;
		btfsc	ave_h,0			;ʃWX^̒lʃWX^Ɉړ
		bsf		ave_l,6			;
		btfsc	ave_h,1			;
		bsf		ave_l,7			;

		rrf		ave_h,f			;ʃWX^̉4rbgړIߏʃWX^1/4ɂB
		rrf		ave_h,f			;
		movlw	b'00000011'			;sƂȂĂ6rbg[}XN
		andwf	ave_h,f			;

		return

;********** ㉺̍XVf **********
hl_cal
	;********** l`FbN **********
		movf	decreg4,w		;
		subwf	decreg2,w		;
		btfss	status,c		;lȉH
		goto	lo_cal			;	Yes. l`FbN
		btfss	status,z		;lƓH
		goto	hi_rnew			;	No. l荂ߏlXV
		
		movf	decreg3,w		;ʃ`FbNł͔łȂ߉ʂ̃`FbN
		subwf	decreg1,w		;
		btfsc	status,c		;lȉH
		goto	hi_rnew			;	No. lȏ̂ߏlXV
								;	Yes. l`FbN

	;********** l`FbN **********
lo_cal	movf	decreg6,w		;
		subwf	decreg2,w		;
		btfss	status,c		;lȏォH
		goto	lo_rnew			;	No. lȉ̂߉lXV
		btfss	status,z		;lƓH
		return					;	No. l荂ߍXV̕Kv͖
		
		movf	decreg5,w		;ʃ`FbNł͔łȂ߉ʂ̃`FbN
		subwf	decreg1,w		;
		btfss	status,c		;lȏォH
		goto	lo_rnew			;	No. lȉ̂߉lXV
		return					;	Yes. XV̕Kv͖

	;********** lXV **********
hi_rnew	movf	decreg2,w		;
		movwf	decreg4			;
		movf	decreg1,w		;
		movwf	decreg3			;
		goto	lo_cal			;܂`FbNsĂȂ߉`FbNֈړ

	;********** lXV **********
lo_rnew	movf	decreg2,w		;
		movwf	decreg6			;
		movf	decreg1,w		;
		movwf	decreg5			;
		return					;ɏ`FbN͊Ă邽ߋA

;********** ADϊʂ2rbgEVtg **********
ave2rrf	bcf		status,c		;EVtg̍ۂɏʂɕslȂ悤ɃL[rbgNA
		rrf		ave_h,f			;2rbgEVtg
		rrf		ave_l,f			;
		rrf		ave_h,f			;
		rrf		ave_l,f			;

		return

;********************************************************
;          ǗpWX^NA
;********************************************************
decregc	clrf	decreg1		;
		clrf	decreg2		;
		clrf	decreg3		;
		clrf	decreg4		;
		clrf	decreg5		;
		clrf	decreg6		;

		return

;********************************************************
;          荞ݏ
;********************************************************
intrpt	movwf   w_save 			;[LOWX^ۑ
        movf    status,w		;Xe[^XWX^ۑ
        movwf   s_save			;
		movf	FSR,w			;FSRۑ
		movwf	f_save			;
		bcf     status,rp0		;荞ݔ̃oNsȂ߃oN0ɋړ
	;***** WX^ۑ *****
		btfsc	intcon,t0if		;^C}0I[o[t[H
		call	m_over			;	Yes. C[vI[o[

		btfsc	intcon,gpif		;pX͂ɂ`l̃xωɂ銄荞ݔH
		call	pls_in			;	Yes. 

	;***** AҏJn *****
int_end	movf	f_save,w		;FSRA
		movwf	FSR				;
		movf    s_save,w		;Xe[^XWX^A
        movwf   status			;
        swapf   w_save,f		;[LOWX^A
        swapf   w_save,w		;
		retfie					;

;********** pX͎ **********
pls_in	movf	gpio,f			;荞ݗvtOZbg邽߂Ƀ|[g[h
		bcf		intcon,gpif		;荞ݗvtOZbg

		incf	pls_cnt,f		;pXJE^CNg
		btfsc	status,z		;I[o[t[H
		decf	pls_cnt,f		;	Yes. tێ邽߃fNg

		return

;********** C[v^C}I[o[ **********
m_over	bcf		intcon,t0if		;荞ݗvtOZbg
		movlw	h'FF'			;ő啉׎ԂIɏ
		movwf	maxmain			;

		return

;********************************************************
;          Timer  Subroutine for 20MHz clock
;********************************************************

;**************  20usec Timer Subroutine  *****************
t20u	movlw	d'20'			;Set loop counter
		movwf	tmr_cnt			;Save loop counter
		nop						;Time adjust
		nop						;Time adjust
		decfsz	tmr_cnt,f		;Timer Counter - 1 = 0 ?
		goto	$-3			;	No.

		return

;**************  500usec Timer Subroutine  *****************
t500u	movlw	d'250'			;Set loop counter
		movwf	tmr_cnt			;Save loop counter
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		decfsz	tmr_cnt,f		;Timer Counteru - 1 = 0 ?
		goto	$-8				;	No.

		return

;*************  1msec Timer Subroutine  *****************
t1m     movlw	d'250'			;Set loop counter
		movwf	tmr_cnt			;Save loop counter
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		nop						;Time adjust
		decfsz	tmr_cnt,f		;Timer Counteru - 1 = 0 ?
		goto	$-12			;	No.
		return

;*************  10msec Timer Subroutine  ***************
t10m    movlw   d'10' 			;Set loop cnt1
        movwf   cnt10m          ;Save loop cnt1
		call	t1m				;1mSec Wait
        decfsz  cnt10m,f        ;cnt10m-1=0 ?
        goto    $-2				;No, continue
		return

;**************  500msec Timer Subroutine  *****************
t500m	movlw	d'50'			;Set loop counter
		movwf	cnt500m			;Save loop counter
		call	t10m			;Time adjust
		decfsz	cnt500m,f		;cnt500u - 1 = 0 ?
        goto    $-2				;	No.

		return

;**************  1sec Timer Subroutine  *****************
t1s     call	t500m			;500mSec Wait
		call	t500m			;500mSec Wait

        return

;********************************************************
;**********************   Page EEPROM   *****************
;********************************************************
        org     2100

		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'
		de		h'00',h'00',h'00',h'00',h'00',h'00',h'00',h'00'

;********************************************************
;          Program END
;********************************************************

	end

